var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import 'react-virtualized/styles.css';
import { IoMdCheckmark } from 'react-icons/io';
import { Table } from 'react-virtualized';
import _ from 'lodash';
import { FaSort, FaSortUp, FaSortDown } from 'react-icons/fa';
import { MdClose } from 'react-icons/md';
import { ContextMenu, MenuItem, ContextMenuTrigger } from 'react-contextmenu';
import { FaPencilAlt, FaTimes } from 'react-icons/fa';
var VirtualizedTable = /** @class */ (function (_super) {
    __extends(VirtualizedTable, _super);
    function VirtualizedTable(props) {
        var _this = _super.call(this, props) || this;
        _this.transform = function (row, column) {
            _this.setState({ row: row, column: column });
        };
        _this.cancel = function () {
            _this.setState({ row: '', column: '' });
        };
        _this.edit = function (column_index, index) {
            var data = __spreadArrays(_this.state.data);
            data[index][_this.state.headers[column_index].dataField] = _this.state.editedValue;
            _this.setState({ row: '', column: '', data: data });
            // this.props.onEdit(id, column_index, index, this.state.editedValue);
        };
        _this.handleEdit = function (event) {
            _this.setState({ editedValue: event.target.value });
        };
        _this.sort = function (sortBy) {
            var dataSet = __spreadArrays(_this.state.data);
            var sortedData = _.orderBy(dataSet, sortBy, _this.state.sortDirection);
            if (_this.state.sortDirection === 'asc') {
                _this.setState({
                    data: sortedData,
                    sortDirection: 'desc',
                    sortedColumn: sortBy,
                    sorted: true
                }, function () { return _this.props.updateTable ? _this.props.updateTable(_this.state.data) : console.log('No function defined'); });
            }
            else {
                _this.setState({
                    data: sortedData,
                    sortDirection: 'asc',
                    sortedColumn: sortBy,
                    sorted: true
                }, function () { return _this.props.updateTable ? _this.props.updateTable(_this.state.data) : console.log('No function defined'); });
            }
        };
        _this.getRowData = function (props) {
            _this.setState({
                rowData: props.rowData,
                rowIndex: props.index,
            });
        };
        _this.renderTable = function (values) {
            var dataSet = __spreadArrays(_this.state.data);
            _this.state.headers.forEach(function (header) {
                if (values[header] !== undefined) {
                    dataSet[_this.state.rowIndex][header] = values[header];
                }
            });
            _this.setState({ data: dataSet });
            _this.props.updateTable ? _this.props.updateTable(_this.state.data) : console.log('No function defined');
        };
        _this.renderRow = function (props) {
            return (React.createElement("div", { style: props.style, className: "d-flex flex-row", onContextMenu: function () { return _this.props.getRow ? _this.props.getRow(props) : console.log('No data'); } },
                React.createElement("input", { type: "checkbox", style: { flex: '0 1 100px', marginTop: '12px' }, onClick: function () { return _this.props.getRow ? _this.props.getRow(props) : console.log('No data'); } }),
                Object.values(props.rowData).map(function (cell, index) {
                    if (_this.state.row === props.rowData.id &&
                        _this.state.column === index) {
                        var data = String(cell);
                        return (React.createElement("span", { className: "table-row" },
                            React.createElement("input", { type: "text", defaultValue: data, className: "transformed-input-style", style: { width: '120px' }, onChange: function (event) { return _this.handleEdit(event); } }),
                            React.createElement(IoMdCheckmark, { className: "icon", onClick: function () {
                                    return _this.edit(index, props.index);
                                } }),
                            React.createElement(MdClose, { className: "icon", onClick: function () { return _this.cancel(); } })));
                    }
                    else {
                        return (React.createElement("span", { className: "table-row", onDoubleClick: function () { return _this.transform(props.rowData.id, index); } }, cell));
                    }
                })));
        };
        _this.renderHeader = function (props) {
            return (React.createElement(React.Fragment, null,
                React.createElement("div", { style: props.style, className: "ReactVirtualized__Table__headerRow header" },
                    React.createElement("input", { type: "checkbox", style: { flex: '0 1 100px', visibility: 'hidden' } }),
                    _this.state.headers.map(function (header) {
                        return (React.createElement("span", { className: "table-row", onClick: function () { return _this.sort(header.dataField); } },
                            header.text,
                            _this.state.sortedColumn === header.dataField ? (_this.state.sortDirection === 'asc' ? (React.createElement(FaSortDown, { className: "margin-left-10" })) : (React.createElement(FaSortUp, { className: "margin-left-10" }))) : (React.createElement(FaSort, { className: "margin-left-10" }))));
                    }))));
        };
        _this.noScroll = function () {
            console.log('No scroll method found');
        };
        console.log(_this.props);
        _this.state = {
            data: _this.props.data,
            headers: _this.props.headers,
            rowData: [],
            sortDirection: 'asc',
            sortedColumn: '',
            row: '',
            column: '',
            editedValue: '',
            rowIndex: '',
            sorted: false,
        };
        return _this;
    }
    VirtualizedTable.prototype.componentDidUpdate = function () {
        if (!this.state.sorted) {
            this.setState({
                data: this.props.data,
                headers: this.props.headers,
            });
        }
    };
    VirtualizedTable.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", null,
            React.createElement(ContextMenuTrigger, { id: "some_unique_identifier" },
                React.createElement(Table, { width: 2000, height: 585, headerHeight: 20, headerClassName: "header", rowHeight: 40, rowCount: this.state.data.length, rowGetter: function (_a) {
                        var index = _a.index;
                        return _this.state.data[index];
                    }, onScroll: this.props.onScroll ? this.props.onScroll() : this.noScroll, isScrolling: true, rowRenderer: this.renderRow, headerRowRenderer: this.renderHeader })),
            this.props.showContextMenu ? (React.createElement(ContextMenu, { id: "some_unique_identifier" },
                this.props.isEdit ? (React.createElement(MenuItem, { onClick: this.props.contextMenuEditModal },
                    React.createElement(FaPencilAlt, null),
                    " ",
                    React.createElement("u", null, "E"),
                    "dit")) : null,
                React.createElement(MenuItem, { divider: true }),
                this.props.isDelete ? (React.createElement(MenuItem, { onClick: this.props.onDelete },
                    React.createElement(FaTimes, null),
                    " ",
                    React.createElement("u", null, "D"),
                    "elete")) : null)) : null));
    };
    return VirtualizedTable;
}(React.PureComponent));
export default VirtualizedTable;
//# sourceMappingURL=VirtualizedTable.js.map