import React from 'react';
import { Button } from 'reactstrap';
import {
  FaPlus,
  FaPencilAlt,
  FaTimes,
  FaRegCheckSquare,
  FaExchangeAlt,
  FaEllipsisV,
  FaShareSquare,
  FaRegFile,
} from 'react-icons/fa';
import { MdPriorityHigh } from 'react-icons/md';
import { IoMdPaper } from 'react-icons/io';
interface Props {
  btnClass: string;
  showHotKey?: boolean;
  actionBtn?: {
    isCreate?: boolean;
    isEdit?: boolean;
    isDelete?: boolean;
    isProcess?: boolean;
    isAssign?: boolean;
    isMarkAs?: boolean;
    isExport?: boolean;
    isReports?: boolean;
    isPriority?: boolean;
    isTemplates?: boolean;
  };
  createBtnOnClick?: () => void;
  editBtnOnClick?: () => void;
  deleteBtnOnClick?: () => void;
}
export default class ActionButton extends React.Component<Props, any> {
  constructor(props:any) {
    super(props);
    this.state = {};
  }
  render() {
    return (
      <div>
        {this.props.actionBtn.isCreate ? (
          <Button
            color={this.props.btnClass}
            onClick={this.props.createBtnOnClick}
            className="action-button"
          >
            {this.props.showHotKey ? (
              <>
                <FaPlus /> <span className="hot-key">C</span>reate
              </>
            ) : (
              <>
                <FaPlus /> <u>C</u>reate
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isEdit ? (
          <Button
            color={this.props.btnClass}
            onClick={this.props.editBtnOnClick}
            className="action-button"
          >
            {this.props.showHotKey ? (
              <>
                <FaPencilAlt /> <span className="hot-key">E</span>
                dit
              </>
            ) : (
              <>
                <FaPencilAlt /> <u>E</u>dit
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isDelete ? (
          <Button
            color={this.props.btnClass}
            onClick={this.props.deleteBtnOnClick}
            className="action-button"
          >
            {this.props.showHotKey ? (
              <>
                <FaTimes /> <span className="hot-key">D</span>
                elete
              </>
            ) : (
              <>
                <FaTimes /> <u>D</u>elete
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isProcess ? (
          <Button color={this.props.btnClass} className="action-button">
            {this.props.showHotKey ? (
              <>
                <FaRegCheckSquare /> <span className="hot-key">P</span>
                rocess
              </>
            ) : (
              <>
                <FaRegCheckSquare /> <u>P</u>rocess
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isAssign ? (
          <Button color={this.props.btnClass} className="action-button">
            <FaExchangeAlt /> Assign
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isMarkAs ? (
          <Button color={this.props.btnClass} className="action-button">
            {this.props.showHotKey ? (
              <>
                <FaEllipsisV /> <span className="hot-key">M</span>
                ark As
              </>
            ) : (
              <>
                <FaEllipsisV /> <u>M</u>ark As
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isExport ? (
          <Button color={this.props.btnClass} className="action-button">
            {this.props.showHotKey ? (
              <>
                <FaShareSquare /> E<span className="hot-key">x</span>
                port
              </>
            ) : (
              <>
                <FaShareSquare /> E<u>x</u>port
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isReports ? (
          <Button color={this.props.btnClass} className="action-button">
            {this.props.showHotKey ? (
              <>
                <FaRegFile /> <span className="hot-key">R</span>
                eports
              </>
            ) : (
              <>
                <FaRegFile /> <u>R</u>eports
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isPriority ? (
          <Button color={this.props.btnClass} className="action-button">
            {this.props.showHotKey ? (
              <>
                <MdPriorityHigh /> <span className="hot-key">S</span>
                et Priority
              </>
            ) : (
              <>
                <MdPriorityHigh /> <u>S</u>et Priority
              </>
            )}
          </Button>
        ) : (
          ''
        )}
        {this.props.actionBtn.isTemplates ? (
          <Button color={this.props.btnClass} className="action-button">
            <IoMdPaper /> Templates
          </Button>
        ) : (
          ''
        )}
      </div>
    );
  }
}
