import React from 'react';
import { Button } from 'reactstrap';
import Hotkeys from 'react-hot-keys';
// import Reorder, { reorder } from 'react-reorder';
import Reorder from 'react-reorder';
interface Props {
    headers?: any;
    data?: any;
    onRef?: any;
    sendSettings?: Function;
}

interface State {
    toggle: boolean;
    modal: boolean;
    list: any;
    column_order: any;
}

export default class ColumnSettings extends React.PureComponent<
    Props,
    State,
    any
    > {
    constructor(props: Props) {
        super(props);
        this.state = {
            toggle: false,
            modal: false,
            list: this.props.headers,
            column_order: [],
        };
    }

    componentDidMount() {
        this.props.onRef(this);
    }
    componentWillUnmount() {
        this.props.onRef(null);
    }

    toggle = () => {
        this.setState({
            toggle: !this.state.toggle,
            modal: !this.state.modal,
        });
    };

    // onReorder(event, previousIndex, nextIndex, fromId, toId) {

    //     this.setState({
    //         list: reorder(this.state.list, previousIndex, nextIndex),
    //     });
    //     var ord = [];
    //     this.state.list.forEach((item) => {
    //         ord.push(item.value);
    //     });
    //     this.setState({
    //         column_order: ord,
    //     });
    // }

    onReorder () {}

    onColumnSwitchApply = () => {
        var reOrder = [];
        var dataSet = [...this.props.data];
        dataSet.forEach(item => {
            var obj = {};
            this.state.column_order.forEach(col => {
                obj[col] = item[col];
            });
            reOrder.push(obj);
        });
        this.props.sendSettings(reOrder, this.state.column_order);
        this.toggle();
    };

    onKeyUp(handle) {
        if (handle.shortcut === 'alt+s') {
            this.toggle();
        }
    }

    onKeyDown() { }

    render() {

        return (
            <div>
                <Hotkeys
                    keyName="alt+s"
                    onKeyDown={this.onKeyDown.bind(this)}
                    onKeyUp={this.onKeyUp.bind(this)}
                >

                    <Reorder
                        reorderId="my-list"
                        reorderGroup="reorder-group"
                        //getRef={this.storeRef.bind(this)}
                        component="p"
                        placeholderClassName="placeholder"
                        draggedClassName="dragged"
                        lock="vertical"
                        holdTime={200}
                        touchHoldTime={200}
                        mouseHoldTime={200}
                        onReorder={this.onReorder.bind(this)}
                        autoScroll={true}
                        disabled={false}
                        disableContextMenus={true}
                        placeholder={
                            <div
                                className="custom-placeholder"
                                style={{
                                    border: '2px dashed #2b4494',
                                    width: '100px',
                                    paddingTop: '10px',
                                    paddingBottom: '10px',
                                    backgroundColor: '#8594c1',
                                    textAlign: 'center',
                                    color: '#fff',
                                    opacity: 0.5,
                                    display: 'inline-block',
                                }}
                            >
                                Drop Here
                            </div>
                        }
                    >
                        {this.state.list.map(item => (
                            <div
                                key={item.value}
                                style={{
                                    border: '1px solid #2b4494',
                                    padding: '10px',
                                    width: 'auto',
                                    marginLeft: '3px',
                                    marginRight: '3px',
                                    display: 'inline-block',
                                    cursor: 'pointer',
                                }}
                            >
                                {item.label}
                            </div>
                        ))}
                    </Reorder>
                    <Button
                        className="submit-button-style"
                        onClick={this.onColumnSwitchApply}
                    >
                        Apply
              </Button>
                </Hotkeys>
            </div>
        );
    }
}
