import React from 'react';
import StepZilla from 'react-stepzilla';
import 'react-stepzilla/src/css/main.css';

interface Props {
  steps: Array<any>;
  showNavigation?: boolean;
  showSteps?: boolean;
  stepsNavigation?: boolean;
  prevBtnOnLastStep?: boolean;
  dontValidate?: boolean;
  preventEnterSubmission?: boolean;
  startAtStep?: number;
  nextButtonText?: string;
  backButtonText?: string;
  nextButtonClass?: string;
  backButtonClass?: string;
  nextTextOnFinalActionStep?: string;
  hoValidationAppliedTo?: Array<number>;
  onStepChange?: () => void;
}
interface State {}

export default class StepZillaWizard extends React.PureComponent<
  Props,
  State,
  any
> {
  constructor(props: Props) {
    super(props);
    this.state = {};
  }

  render() {
    return (
      <div>
        <StepZilla
          steps={this.props.steps}
          showNavigation={this.props.showNavigation}
          showSteps={this.props.showSteps}
          stepsNavigation={this.props.stepsNavigation}
          prevBtnOnLastStep={this.props.prevBtnOnLastStep}
          dontValidate={this.props.dontValidate}
          preventEnterSubmission={this.props.preventEnterSubmission}
          startAtStep={this.props.startAtStep}
          nextButtonText={this.props.nextButtonText}
          backButtonText={this.props.backButtonText}
          nextButtonCls={this.props.nextButtonClass}
          backButtonCls={this.props.backButtonClass}
          nextTextOnFinalActionStep={this.props.nextTextOnFinalActionStep}
          hocValidationAppliedTo={this.props.hoValidationAppliedTo}
          onStepChange={this.props.onStepChange}
        />
      </div>
    );
  }
}
