import React from 'react';
import InputProps from '../../models/InputProps';
import {
    TabContent,
    TabPane,
    Nav,
    NavItem,
    NavLink,
} from 'reactstrap';
import DynamicForm from './DynamicForm';
// import { generateYupSchema } from 'utils/Form';
import classnames from 'classnames';
import Table from './BootstrapTableNext';

// Initialize State
interface State {
    activeTab: String;
    form?: Array<any>;
    classes?: string;
}

export default class TabComponent extends React.Component<
    InputProps,
    State,
    any
    > {
    // intialize the active tab, class
    state = { activeTab: this.props.field.tabActive, classes: 'col-md-12' };

    // Event Handlers
    changeHandler() {
        // console.log(this.state);
    }

    // OnSubmit function
    onFormSubmit() {
        // console.log(values);
    }

    componentWillMount() {
        // inittialize the active tabs
        this.setState({
            activeTab: this.props.field.tabActive,
            classes: 'col-md-12',
        });
    }

    render() {
        // const validateSchema = generateYupSchema(fields);
        // Toggle the Active tab
        const toggle = tab => {
            this.setState({
                activeTab: tab,
            });
        };

        return (
            <div
                className={
                    this.props.field.classNames
                        ? this.props.field.classNames
                        : this.state.classes
                }
                key={this.props.name}
            >
                <Nav tabs>
                    {this.props.field.tabList.map((tab) => {
                        return (
                            <NavItem>
                                <NavLink
                                    className={classnames({
                                        active: this.state.activeTab === tab.title,
                                    })}
                                    onClick={() => {
                                        toggle(tab.title);
                                    }}
                                >
                                    {tab.title}
                                </NavLink>
                            </NavItem>
                        );
                    }, this)}
                </Nav>
                <TabContent
                    activeTab={this.state.activeTab}
                    style={{
                        borderRight: '1px solid #dee2e6',
                        borderLeft: '1px solid #dee2e6',
                        borderBottom: '1px solid #dee2e6',
                    }}
                >
                    {this.props.field.tabList.map((tab) => {
                        return (
                            <TabPane
                                tabId={tab.title}
                                style={{ backgroundColor: 'red !important' }}
                            >
                                {typeof tab.tabcontent !== 'string' ? (
                                    <div>
                                        <DynamicForm
                                            key="json-form"
                                            // form={form}
                                            layout={'grid'}
                                            promptIfUnsaved={true}
                                            layoutGrid={4}
                                            labelPosition="right"
                                            fields={tab.tabcontent}
                                            // validation={validateSchema}
                                            onFormSubmit={this.onFormSubmit}
                                            changeHandler={this.changeHandler}
                                        />
                                        {tab.hasTable && (
                                            <Table
                                                name={tab.tableData.name}
                                                keyField="id"
                                                data={tab.tableData.data}
                                                columns={tab.tableData.columns}
                                                actionButtons={tab.tableData.actionButtons}
                                            />
                                        )}
                                    </div>
                                ) : (
                                        <div>
                                            {tab.tabcontent}
                                            {tab.hasTable && (
                                                <Table
                                                    name={tab.tableData.name}
                                                    keyField="id"
                                                    data={tab.tableData.data}
                                                    columns={tab.tableData.columns}
                                                    actionButtons={tab.tableData.actionButtons}
                                                />
                                            )}
                                        </div>
                                    )}
                            </TabPane>
                        );
                    })}
                </TabContent>
            </div>
        );
    }
}
