import InputOption from './InputOption';

export interface FieldConfig {
  // arrayIndex?: number;
  arrayFieldName?: string;
  arrayFields?: {
    headers: Array<{
      label: string;
      width: number;
      key: string;
      required?: boolean;
    }>;
    fields: Array<FieldConfig>;
  };
  classNames?: string;
  disabled?: boolean;
  id?: string;
  isArrayField?: boolean;
  isMulti?: boolean;
  isRequired?: boolean;
  label?: string;
  name: string;
  place?: number;
  placeholder?: string;
  position?: 'grid' | 'inline' | 'vertical';
  buttonType?: 'button' | 'submit' | 'reset';
  positionGrid?: number;
  onChange?: Function;
  onBlur?: Function;
  options?: Array<InputOption>;
  title?: string;
  type:
    | 'text'
    | 'email'
    | 'textarea'
    | 'password'
    | 'datepicer'
    | 'timepicker'
    | 'datepicker'
    | 'datetimepicker'
    | 'toggle'
    | 'select'
    | 'checkbox'
    | 'number'
    | 'checkbox_group'
    | 'radio'
    | 'multi_select'
    | 'decimal'
    | 'button'
    | 'array_fields'
    | 'tab'; // Added Tab Component
  validations?: Array<{
    type:
      | 'required'
      | 'string'
      | 'min'
      | 'max'
      | 'email'
      | 'url'
      | 'matches'
      | 'number';
    params: Array<any>;
  }>;
  validation?: {
    required?: {
      message?: string;
    };
    min?: {
      message?: string;
      v: number;
    };
    max?: {
      message?: string;
      v: number;
    };
    pattern?: RegExp;
  };
  validationType?: any;
  value?: any;
  // Field Configuration for Tab component
  tabActive?: string;
  tabList?: Array<{
    id: string;
    title: string;
    tabcontent: string | Array<any>;
    actionButton?: Array<any>;
    hasTable?: boolean;
    tableData?: any;
  }>;
}

export default FieldConfig;
