import React from 'react';
import { action } from '@storybook/addon-actions';
import { Button } from 'reactstrap';

import 'bootstrap/dist/css/bootstrap.min.css';

import './../index.css';
import './../custom.scss';

import ActionButton from './../components/lib/ActionButton';
// import Button from './../components/lib/Button';

const actionButtonData = {
  isCreate: true,
  isEdit: true,
  isDelete: true,
  isProcess: true,
  isAssign: true,
  isMarkAs: true,
  isExport: true,
  isReports: true,
  isPriority: true,
  isTemplates: true
};

export default {
  title: 'Button',
  component: Button,
  parameters: {
    notes: 'some documentation here',
    info: {
      title: 'Welcome'
    },
  },
};

export const Buttons = () => {
  return (
    <div style={{ marginTop: '10px', marginLeft: '10px' }}>
       <Button color="primary" onClick={action('clicked')}>Hello Button</Button>
    </div>
  )
};

Buttons.story = {
  name: 'Basic Buttons',
};

export const ActionButton1 = () => {
  return (
    <div style={{ marginTop: '10px', marginLeft: '10px' }}>
      <ActionButton btnClass="primary" actionBtn={actionButtonData} />
    </div>
  )
};

ActionButton1.story = {
  name: 'Action Buttons',
};
