import React, { useState } from 'react';
import { Button, Modal, ModalHeader, ModalBody, ModalFooter } from 'reactstrap';

export default {
  title: 'Modal',
  component: Modal,
};

export const Modal1 = () => {
  const [modal, setModal] = useState(false);
  const toggle = () => setModal(!modal);
  return (
    <div style={{ marginTop: '10px', marginLeft: '10px', marginRight: '10px' }}>
      <Button color="danger" onClick={toggle}>Click to open modal</Button>
      <Modal isOpen={modal} toggle={toggle}>
        <ModalHeader toggle={toggle}>Modal title</ModalHeader>
        <ModalBody>
          This is a basic modal
          </ModalBody>
        <ModalFooter>
          <Button color="primary" onClick={toggle}>Close</Button>
        </ModalFooter>
      </Modal>
    </div>
  )
};

Modal1.story = {
  name: 'Modal',
};
export const FocusModal = () => {
  const [modal, setModal] = useState(false);
  
  const toggle = () => { setModal(!modal) };
  
  return (
    <div style={{ marginTop: '10px', marginLeft: '10px', marginRight: '10px' }}>
      <Button color="danger" onClick={toggle}>Click to open modal</Button>
      <Modal isOpen={modal} toggle={toggle} autoFocus={false}>
        <ModalHeader toggle={toggle}>Modal title</ModalHeader>
        <ModalBody>
          <label>Input</label>
          <input
          type='text'
          autoFocus={true} />
        </ModalBody>
        <ModalFooter>
          <Button color="primary" onClick={toggle}>Close</Button>
        </ModalFooter>
      </Modal>
    </div>
  )
};

FocusModal.story = {
  name: 'Modal with focus event',
};