import React from 'react';
import BootstrapTableNext from '../components/lib/BootstrapTableNext';
import VirtualizedTable from '../components/lib/VirtualizedTable';

const data = {
  name: 'IBR',
  keyField: 'id',
  data: [
    {
      id: 1,
      transport_method: 'DHL',
      date: 'Feb 12 2020 18:08:43',
      container_count: 20,
      status: 'In-Process',
      receipt_id: '400/US01-000005673',
      location: 'US01-VA03',
    },
    {
      id: 2,
      transport_method: 'DHL',
      date: 'Feb 12 2020 18:08:43',
      container_count: 40,
      status: 'In-Process',
      receipt_id: '400/US01-000005343',
      location: 'US01-VA03',
    },
    {
      id: 3,
      transport_method: 'DHL',
      date: 'Feb 12 2020 18:08:43',
      container_count: 120,
      status: 'In-Process',
      receipt_id: '400/US01-000005346',
      location: 'US01-VA03',
    },
    {
      id: 4,
      transport_method: 'FedEx',
      date: 'Feb 12 2020 18:08:43',
      container_count: 44,
      status: 'In-Process',
      receipt_id: '400/US01-000005348',
      location: 'US01-VA03',
    },
    {
      id: 5,
      transport_method: 'Ryder',
      date: 'Feb 12 2020 18:08:43',
      container_count: 20,
      status: 'In-Process',
      receipt_id: '400/US01-000005349',
      location: 'US01-VA03',
    },
    {
      id: 6,
      transport_method: 'FedEx',
      date: 'Feb 13 2020 18:08:43',
      container_count: 24,
      status: 'In-Process',
      receipt_id: '400/US01-000005333',
      location: 'US01-VA03',
    },
    {
      id: 7,
      transport_method: 'DHL',
      date: 'Feb 13 2020 18:08:43',
      container_count: 20,
      status: 'New',
      receipt_id: '400/US01-000005334',
      location: 'US01-VA03',
    },
    {
      id: 8,
      transport_method: 'DHL',
      date: 'Feb 13 2020 18:08:43',
      container_count: 30,
      status: 'In-Process',
      receipt_id: '400/US01-000005335',
      location: 'US01-VA03',
    },
    {
      id: 9,
      transport_method: 'FedEx',
      date: 'Feb 13 2020 18:08:43',
      container_count: 20,
      status: 'In-Process',
      receipt_id: '400/US01-000005336',
      location: 'US01-VA03',
    },
    {
      id: 10,
      transport_method: 'Ryder',
      date: 'Feb 13 2020 18:08:43',
      container_count: 22,
      status: 'In-Process',
      receipt_id: '400/US01-000005337',
      location: 'US01-VA03',
    },
    {
      id: 11,
      transport_method: 'DHL',
      date: 'Feb 14 2020 18:08:43',
      container_count: 20,
      status: 'In-Process',
      receipt_id: '400/US01-000005338',
      location: 'US01-VA03',
    },
    {
      id: 12,
      transport_method: 'DHL',
      date: 'Feb 14 2020 18:08:43',
      container_count: 21,
      status: 'In-Process',
      receipt_id: '400/US01-000005338',
      location: 'US01-VA03',
    },
  ],
  columns: [
    {
      dataField: 'id',
      text: 'ID',
      sort: true,
    },
    {
      dataField: 'transport_method',
      text: 'Transport Method',
      sort: true,
      searchable: true,
    },
    {
      dataField: 'date',
      text: 'Received Date',
      sort: true,
    },
    {
      dataField: 'container_count',
      text: 'Container Count',
      sort: true,
    },
    {
      dataField: 'status',
      text: 'Status',
      sort: true,
    },
    {
      dataField: 'receipt_id',
      text: 'Receipt ID',
      sort: true,
    },
    {
      dataField: 'location',
      text: 'Location',
      sort: true,
    },
  ],
};

export default {
  title: 'Table',
  component: BootstrapTable1,
};

export const BootstrapTable1 = () => {
  return (
    <div style={{ marginTop: '10px', marginLeft: '10px', marginRight: '10px' }}>
      <BootstrapTableNext
        key="id"
        name={data.name}
        keyField={data.keyField}
        data={data.data}
        columns={data.columns}
        showHotKey={false}
      />
    </div>
  )
};

BootstrapTable1.story = {
  name: 'Bootstrap Table',
};

export const Virtualized = () => {
  return (
    <div style={{ marginTop: '10px', marginLeft: '10px', marginRight: '10px' }}>
      <VirtualizedTable
        data={data.data} headers={data.columns}
      />
    </div>
  )
};

Virtualized.story = {
  name: 'Virtualized Table',
};